import glob
import os
import sys
try:
    directory = sys.argv[1]
except:
    sys.stderr.write("Usage: 0-splitGff.py directory_with_gff_files\n")
    sys.exit(0)

transl_dict = {'Tapidor_chrA04_v6.3': 'ta04', 'Tapidor_chrA02_v6.3': 'ta02', 'chrC04_contigs_placed_v81': 'da14', 'chrC02_contigs_placed_v81': 'da12', 'Tapidor_chrC07_v6.3': 'ta17', 'chrC06_contigs_placed_v81': 'da16', 'Tapidor_chrA07_v6.3': 'ta07', 'Tapidor_chrC06_v6.3': 'ta16', 'chrA03_contigs_placed_v81': 'da03', 'chrA06_contigs_placed_v81': 'da06', 'chrC05_contigs_placed_v81': 'da15', 'Tapidor_chrA09_v6.3': 'ta09', 'Tapidor_chrC05_v6.3': 'ta15', 'chrA07_contigs_placed_v81': 'da07', 'Tapidor_chrA06_v6.3': 'ta06', 'Tapidor_chrA10_v6.3': 'ta10', 'Tapidor_chrC02_v6.3': 'ta12', 'Tapidor_Unplaced_v6.3': 'ta20', 'Tapidor_chrA08_v6.3': 'ta08', 'Tapidor_chrC04_v6.3': 'ta14', 'chrA01_contigs_placed_v81': 'da01', 'Tapidor_chrC09_v6.3': 'ta19', 'Tapidor_chrC01_v6.3': 'ta11', 'Unplaced_contigs_v81': 'da20', 'chrA09_contigs_placed_v81': 'da09', 'chrC01_contigs_placed_v81': 'da11', 'Tapidor_chrC08_v6.3': 'ta18', 'chrC09_contigs_placed_v81': 'da19', 'chrA05_contigs_placed_v81': 'da05', 'chrC08_contigs_placed_v81': 'da18', 'chrA04_contigs_placed_v81': 'da04', 'chrA02_contigs_placed_v81': 'da02', 'chrA10_contigs_placed_v81': 'da10', 'Tapidor_chrA01_v6.3': 'ta01', 'chrC03_contigs_placed_v81': 'da13', 'Tapidor_chrA03_v6.3': 'ta03', 'Tapidor_chrC03_v6.3': 'ta13', 'Tapidor_chrA05_v6.3': 'ta05', 'chrC07_contigs_placed_v81': 'da17', 'chrA08_contigs_placed_v81': 'da08'}

fh_dict = {}
blast_fh_dict = {}
for key in {v: k for k, v in transl_dict.items()}:
    if "20" in key:
        # 20 is unplaced, ignore those
        continue
    os.popen("mkdir %s"%key)
    fh = open("%s/%s.gff"%(key,key),"w")
    blast_fh = open("%s/%s.blast"%(key,key),"w")
    fh_dict[key] = fh
    blast_fh_dict[key] = blast_fh

# first split the gff
for l in glob.glob(os.path.join(directory, "*gff")):
    for line in open(l):
        # format    da12    maker-Darmor_chrC02-augustus-gene-1.210-mRNA-1  91846   92932
        if line.startswith("#"): continue
        ll = line.split()
        if ll[2] != "match": continue
        chrom = ll[0]
        short = transl_dict[chrom] # da1
        if "20" in short: continue
        fh = fh_dict[short]

        name = ll[-1].split(";")[1].replace("Name=","")

        fh.write("%s\t%s\t%s\t%s\n"%(short, name, ll[3], ll[4]))
        if "da" in short:
            fh = fh_dict[short.replace("da","ta")]
        else:
            fh = fh_dict[short.replace("ta","da")]
        fh.write("%s\t%s\t%s\t%s\n"%(short, name, ll[3], ll[4]))


# now split the blast hits

for line in open("Both_snap_vs_each_other.txt"):
    ll = line.split()
    query = ll[0]
    # maker-chrC04_contigs_placed_v81-snap-gene-0.93-mRNA-1
    chrom_query = query.split("-")[1]
    chrom_subject = ll[1].split("-")[1]

    short_query, short_subject = transl_dict[chrom_query], transl_dict[chrom_subject]
    if short_query == short_subject: continue
    short_query = short_query.replace("da","").replace("ta","")
    short_subject = short_subject.replace("da","").replace("ta","")
    if short_query != short_subject: continue
    short = transl_dict[chrom_query]
    if "20" in short: continue
    fh = blast_fh_dict[short]
    fh.write(line)

    if "da" in short:
        fh = blast_fh_dict[short.replace("da","ta")]
    else:
        fh = blast_fh_dict[short.replace("ta","da")]
    fh.write(line)
