from bs4 import BeautifulSoup
import sys

try:
    fh = open(sys.argv[1])
except IndexError:
    sys.stderr.write("Usage: python 1-htmlToCsv.py MCScanX_output.html\n")
    sys.exit(0)

assert ".html" in fh.name
out = fh.name.rstrip(".html") + ".csv"
out = open(out, "w")

soup = BeautifulSoup(u'\n'.join(fh.readlines()), "html.parser")
table = soup.find("table")
last_cols = {} # key: column number, value: last seen proper gene that wasnt "| |" for that column
for row in table.find_all("tr"):
    cols = row.find_all("td")
    cols = [element.text.strip().encode("utf-8") for element in cols]
    if not last_cols:
        for counter, element in enumerate(cols[1:]):
            last_cols[counter] = element
    else:
        for counter, element in enumerate(cols[1:]):
            if "|" in element:
                cols[counter + 1] = last_cols[counter]
            else:
                last_cols[counter] = element

    out.write("\t".join(cols).encode('utf-8') + "\n")
