
import sys

try:
    fh = open(sys.argv[1])
    gff = open(sys.argv[2])
except IndexError:
    sys.stderr.write("Usage: python 3-getExpectedRangeForMissing.py file_with_merged.csv positions_with_Mcscan_Gff.gff\n")
    sys.exit(0)

assert "_merged.csv" in fh.name

out = open(fh.name.replace("_merged.csv", "_missing_expected_ranges.csv"), "w")
#example output:
#genemark-Darmor_chrC06-processed-gene-81.26-mRNA-1      maker-Tapidor_chrC06-augustus-gene-49.209-mRNA-1        ta16    4973018 4973750 snap_masked-Tapidor_chrC06-processed-gene-59.71-mRNA-1  ta16    5909946 5910626

start_end_dict = {} # key: gene name, value [chrom, start, end]

for line in gff:
    ll = line.split()
    chrom, name, start, end = ll
    start, end = int(start), int(end)
    start_end_dict[name] = (chrom, start, end)

header = fh.readline().split()
if header[0] != "Gene":
    sys.stderr.write("Error: this is not a merged csv from 2-getLongestBlockPerBlock.py\n")
    sys.exit(1)


current_gene = "START"
list_of_genes_not_in_block = []
for line in fh:
    ll = line.rstrip("\n\r").split("\t")
    if len(ll) == 1:
        # gene not in block
        list_of_genes_not_in_block.append(ll[0])
    else:
        # the next partner-gene is the first gene of the next block
        next_gene = ll[-2]
        #print "last:%s"%current_gene, list_of_genes_not_in_block, "next:%s"%next_gene
        if current_gene != "START":
            last_gene_chrom, last_gene_start, last_gene_end = start_end_dict[current_gene]
        else:
            last_gene_chrom, last_gene_start, last_gene_end = 3*["START"]

        next_gene_chrom, next_gene_start, next_gene_end = start_end_dict[next_gene]

        # we can have the possibility that next gene is located before the last gene on the chromosome - if so, switch both
        if (next_gene_start < last_gene_start) and (last_gene_start != "START"):
            next_gene, next_gene_chrom, next_gene_start, next_gene_end, current_gene, last_gene_chrom, last_gene_start, last_gene_end = \
                   current_gene, last_gene_chrom, last_gene_start, last_gene_end, next_gene, next_gene_chrom, next_gene_start, next_gene_end


        for gene in list_of_genes_not_in_block:
            out.write("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n"%(gene, current_gene, last_gene_chrom, last_gene_start, last_gene_end, next_gene, next_gene_chrom, next_gene_start, next_gene_end))

        # the last partner-gene is the last gene of the last block
        current_gene = ll[-1]
        list_of_genes_not_in_block = []


# now print the last remaining genes, the "overhang"
for gene in list_of_genes_not_in_block:
    last_gene_chrom, last_gene_start, last_gene_end = start_end_dict[current_gene]

    next_gene = "END"
    next_gene_chrom, next_gene_start, next_gene_end = 3*["END"] 

    out.write("%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\t%s\n"%(gene, current_gene, last_gene_chrom, last_gene_start, last_gene_end, next_gene, next_gene_chrom, next_gene_start, next_gene_end))
